/****************************************************************
Project : PPE SERRE
Version : 1
// --------------------------------------------------------------
Fichier source : tempserr.c
Date de  cration : 05/03/2008
Mise  jour le : 19/11/2010
// --------------------------------------------------------------
Author  : Philippe Mariano
Company : Lyce Pierre Emile Martin 18000 BOURGES
// --------------------------------------------------------------
Comments: Lecture de la temprature avec un DS1621 et affichage
 sur un LCD
// --------------------------------------------------------------
Cross compilateur: CVAVR 2.04.5b
// --------------------------------------------------------------
Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
****************************************************************/

#include <mega8535.h>

// =============================================================================================================================
// Bibliothques  rajouter
// -----------------------------------------------------------------------------------------------------------------------------
#include <stdio.h>  	                // contient la fonction sprintf()
#include <stdlib.h> 	                // contient la fonction abs()
#include <delay.h>  	                // contient la fonction delay_ms()
// ----------------------------------------------------------------------------------------------------------------------------
// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>
// ----------------------------------------------------------------------------------------------------------------------------
// DS1621 Thermometer/Thermostat functions
#include <ds1621.h>
// ----------------------------------------------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>
// ----------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------------------
// Programme principal
// ----------------------------------------------------------------------------------------------------------------------------
void main(void)
{
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------------------------------
// Type             Nom                                                     Description
// -----------------------------------------------------------------------------------------------------------------------------
char display_buffer[17];     	            // Tampon pour la premire ligne de l'afficheur
int temperature;		                    // Image de la temprature mesure par le DS1621
// =============================================================================================================================
// Initialisation
// -----------------------------------------------------------------------------------------------------------------------------
// I2C Bus initialization
i2c_init();

// DS1621 Thermometer/Thermostat initialization
// tlow: 50C
// thigh: 55C
// Tout polarity: 0
ds1621_init(0,50,55,0);

// LCD module initialization
lcd_init(16);
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Boucle principale
// -----------------------------------------------------------------------------------------------------------------------------
while (1)
      {  // Dbut while

// ----------------------------------------------------- Lecture de la temprature ---------------------------------------------
temperature = ds1621_temperature_10(0);

// ---------------------------------------------------------Traitement----------------------------------------------------------
sprintf(display_buffer,"T=%-i.%-u%-cC",temperature/10,abs(temperature%10),0xdf);

// --------------------------------------------------------- Affichage ---------------------------------------------------------
lcd_gotoxy(0,0);
lcd_puts(display_buffer);
delay_ms(1000);

      };// Fin while
}
// =============================================================================================================================